# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/02_clean.ipynb.

# %% auto 0
__all__ = ['normalize_whitespace', 'remove_empty_lines']

# %% ../nbs/02_clean.ipynb 2
import re

# %% ../nbs/02_clean.ipynb 4
def normalize_whitespace(
    text: str, # The text to normalize
) -> str: # The normalized text
    """
    Replace runs of whitespace with a single space, strip leading/trailing whitespace,
    and normalize all newlines to unix-style newlines.
    """
    return re.sub(r"\s+", " ", text.strip()).replace("\r\n", "\n")

# %% ../nbs/02_clean.ipynb 5
def remove_empty_lines(
    text: str, # The text to remove empty lines from
) -> str: # The text with empty lines removed
    """
    Remove empty lines from the text.
    """
    return re.sub(r"^\s*$", "", text, flags=re.MULTILINE)
